/** @file ppSubVersion.c
 *
 *  @brief
 *
 *  @ingroup ppSub
 *
 *  @author IfA
 *  @version $Revision: 1.4 $ $Name: not supported by cvs2svn $
 *  @date $Date: 2009-02-18 00:31:20 $
 *  Copyright 2009 Institute for Astronomy, University of Hawaii
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <pslib.h>
#include <psmodules.h>
#include <ppStats.h>

#include "ppSub.h"

psString ppSubVersion(void)
{
#ifndef PPSUB_VERSION
#error "PPSUB_VERSION is not set"
#endif
#ifndef PPSUB_BRANCH
#error "PPSUB_BRANCH is not set"
#endif
    return psStringCopy(PPSUB_BRANCH "@" PPSUB_VERSION);
}

psString ppSubSource(void)
{
#ifndef PPSUB_SOURCE
#error "PPSUB_SOURCE is not set"
#endif
    return psStringCopy(PPSUB_SOURCE);
}

psString ppSubVersionLong(void)
{
    psString version = ppSubVersion();  // Version, to return
    psString source = ppSubSource();    // Source

    psStringPrepend(&version, "ppSub ");
    psStringAppend(&version, " from %s, built %s, %s", source, __DATE__, __TIME__);
    psFree(source);

#ifdef __OPTIMIZE__
    psStringAppend(&version, " optimised");
#else
    psStringAppend(&version, " unoptimised");
#endif

    return version;
};


void ppSubVersionMetadata(psMetadata *metadata)
{
    PS_ASSERT_METADATA_NON_NULL(metadata,);

    psString pslib = psLibVersionLong();// psLib version
    psString psmodules = psModulesVersionLong(); // psModules version
    psString ppStats = ppStatsVersionLong(); // ppStats version
    psString ppSub = ppSubVersionLong(); // ppSub version

    psTime *time = psTimeGetNow(PS_TIME_TAI); // The time now
    psString timeString = psTimeToISO(time); // The time in an ISO string
    psFree(time);
    psString head = NULL;               // Head string
    psStringAppend(&head, "ppSub processing at %s. Component information:", timeString);
    psFree(timeString);

    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, head, "");
    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, pslib, "");
    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, psmodules, "");
    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, ppStats, "");
    psMetadataAddStr(metadata, PS_LIST_TAIL, "HISTORY", PS_META_DUPLICATE_OK, ppSub, "");

    psFree(head);
    psFree(pslib);
    psFree(psmodules);
    psFree(ppStats);
    psFree(ppSub);

    return;
}
